    //
//  AccessoryVC.m
//  RN-iAP
//
//  Created by Phillip Corrigan on 7/18/10.
//  Copyright 2010 Roving Networks, Inc. All rights reserved.
//

#import "AccessoryVC.h"
#import "EAController.h"


@implementation AccessoryVC

@synthesize group1 = _group1;
@synthesize group2 = _group2;
@synthesize statusGroup = _statusGroup;
@synthesize protocolLabel = _protocolLabel;
@synthesize statusLabel = _statusLabel;
@synthesize textView = _textView;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
	
	UIImage *stretchedGroupImage = [[UIImage imageNamed:@"group_bkg.png"] stretchableImageWithLeftCapWidth:20 topCapHeight:20];
	[_group1 setImage:stretchedGroupImage];
	[_group2 setImage:stretchedGroupImage];
	[_statusGroup setImage:stretchedGroupImage];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)viewWillAppear:(BOOL)animated
{
	NSLog(@"viewWillAppear:");
	[_textView setText:@""];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(_accessoryConnected:) name:EAAccessoryDidConnectNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(_accessoryDisconnected:) name:EAAccessoryDidDisconnectNotification object:nil];
    [[EAAccessoryManager sharedAccessoryManager] registerForLocalNotifications];
	
    EAController *eac = [EAController sharedController];
	if ([eac selectedAccessory] == nil || ![eac openSession])
	{
		[self showNoConnectionAlert];
	}
	else
	{
		[eac setAccessoryVC:self];
		[_statusLabel setText:@"Connected"];
		[_protocolLabel setText:[eac protocolString]];
	}
}

- (void)viewWillDisappear:(BOOL)animated
{
	NSLog(@"viewWillDisappear:");
    [[NSNotificationCenter defaultCenter] removeObserver:self name:EAAccessoryDidConnectNotification object:nil];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:EAAccessoryDidDisconnectNotification object:nil];
}


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

- (IBAction)doProtocolInfo:(id)sender
{
	EAAccessory *accessory = [[EAController sharedController] selectedAccessory];
	NSString *s = [NSString stringWithFormat:@"\nName: %@\nManufacturer: %@\nModel Number: %@\nSerial Number: %@\nFirmware Revision: %@\nHardware Revision: %@\nProtocols: %@\n\n\n\n\n",
				   accessory.name, accessory.manufacturer, accessory.modelNumber, accessory.serialNumber, accessory.firmwareRevision, accessory.hardwareRevision, [accessory.protocolStrings objectAtIndex:0]];
    UIAlertView *accessoryInfo = [[UIAlertView alloc] initWithTitle:[accessory name] message:s/*[accessory description]*/ delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [accessoryInfo show];
    [accessoryInfo release];
}


- (void)showNoConnectionAlert
{
	UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"No Accessory is Connected", @"Alert title") 
														message:NSLocalizedString(@"You must first connect to an Accessory", @"Alert meesage")
													   delegate:self
											  cancelButtonTitle:NSLocalizedString(@"Cancel", @"Cancel Button")
											  otherButtonTitles:nil];
	[alertView show];
	[alertView release];
}


- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex
{
	exit(0);
}


- (void)appendData:(NSString *)data
{
	NSLog(@"appendData:");
	NSString *s = [NSString stringWithFormat:@"%@%@", [_textView text], data];
	[_textView setText:s];
}


- (void)_accessoryConnected:(NSNotification *)notification
{
	NSLog(@"accessoryConnected:");
}


- (void)_accessoryDisconnected:(NSNotification *)notification
{
	NSLog(@"accessoryDisconnected:");
}



@end
