//
//  EAController.h
//  RN-iAP
//
//  Created by Phillip Corrigan on 7/10/10.
//  Copyright 2010 Roving Networks, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <ExternalAccessory/ExternalAccessory.h>

@class AccessoryVC;

@interface EAController : NSObject <EAAccessoryDelegate, NSStreamDelegate>
{
    NSMutableArray *_accessoryList;
    EAAccessory *_selectedAccessory;
    EASession *_session;
    NSString *_protocolString;

    NSMutableData *_writeDataBuffer;
	
	AccessoryVC *_accessoryVC;
}
@property (nonatomic, retain, readonly) EAAccessory *selectedAccessory;
@property (nonatomic, copy) NSString *protocolString;
@property (retain) NSMutableData *writeDataBuffer;
@property (nonatomic, assign) AccessoryVC *accessoryVC;


+ (EAController *)sharedController;

- (void)setupControllerForAccessory:(EAAccessory *)accessory withProtocolString:(NSString *)protocolString;

- (BOOL)openSession;
- (void)closeSession;

- (void)writeData:(NSData *)data;

- (BOOL)isAccessoryConnected;

// from EAAccessoryDelegate
- (void)accessoryDidDisconnect:(EAAccessory *)accessory;

// from EAAccessory notifications
- (void)accessoryConnected:(NSNotification *)notification;
- (void)accessoryDisconnected:(NSNotification *)notification;


@end
