//
//  LoopbackVC.m
//  RN-iAP
//
//  Created by Phillip Corrigan on 7/17/10.
//  Copyright 2010 Roving Networks, Inc. All rights reserved.
//

#import "LoopbackVC.h"
#import "EAController.h"



@implementation LoopbackVC

@synthesize loopbackButton = _loopbackButton;
@synthesize sentBuf = _sentBuf;


 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
	NSLog(@"LoopbackVC-initWithNibName:");
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]))
	{
        // Custom initialization
		UITabBarItem *tbItem = [self tabBarItem];
		[tbItem setTitle:@"Loopback"];
		UIImage *tbImage = [UIImage imageNamed:@"loopback.png"];
		[tbItem setImage:tbImage];
		
		_loopbackIsOn = NO;
    }
    return self;
}

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
}


// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
//    return (interfaceOrientation == UIInterfaceOrientationPortrait);
	return YES;
}


- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
	_loopbackIsOn = NO;
	[_loopbackButton setTitle:@"Start Loopback Test" forState:UIControlStateNormal];
}



- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc
{
	[_loopbackButton release];
	[_textView release];
	[_group1 release];
	[_group2 release];
    [super dealloc];
}


- (IBAction)doLoopback:(id)sender
{
	UIButton *b = (UIButton *)sender;
	if (!_loopbackIsOn)
	{
		// Begin loopback
		_loopbackIsOn = YES;
		[b setTitle:@"Stop Loopback Test" forState:UIControlStateNormal];
		[self send128bytes];
	}
	else
	{
		// Stop loopback
		_loopbackIsOn = NO;
		[b setTitle:@"Start Loopback Test" forState:UIControlStateNormal];
	}
}


- (void)send128bytes
{
	uint8_t buf[129];
    for(int i = 0; i < 128; i++)
	{
        buf[i] = (arc4random() % 93) + 0x21;
    }
    [[EAController sharedController] writeData:[NSData dataWithBytes:buf length:128]];
    buf[128] = '\0';
	if ([_sentBuf length])
	{
		self.sentBuf = [NSString stringWithFormat:@"%@%@", _sentBuf, [[[NSString alloc] initWithUTF8String:(const char *)buf] autorelease]];
	}
	else
	{
		self.sentBuf = [[[NSString alloc] initWithUTF8String:(const char *)buf] autorelease];
	}
	NSLog(@"LoopbackVC-send128bytes [%@]", _sentBuf);
	NSString *s = [NSString stringWithFormat:@"%@%@", [self.textView text], @"Sent 128 bytes\nWaiting...\n"];
	[self.textView setText:s];
}


- (void)appendData:(NSString *)data
{
	NSLog(@"LoopbackVC-appendData: [%@]", data);
	NSUInteger len = [data length];
	NSString *partialStr = [_sentBuf substringToIndex:len];
	if (NSOrderedSame == [partialStr compare:data])
	{
		NSString *s = [NSString stringWithFormat:@"%@%@ %d %@", [self.textView text], @"Received", len, @"bytes\nSUCCESS\n"];
		[self.textView setText:s];
		self.sentBuf = [_sentBuf substringFromIndex:len];
		if ([_sentBuf length] < 128)
			[self send128bytes];
	}
	else
	{
		NSString *s = [NSString stringWithFormat:@"%@%@ %d %@", [self.textView text], @"Received", len, @"bytes\nERROR\n"];
		[self.textView setText:s];
		_loopbackIsOn = NO;
		[_loopbackButton setTitle:@"Start Loopback Test" forState:UIControlStateNormal];
	}
}



@end
