//
//  ManualVC.m
//  RN-iAP
//
//  Created by Phillip Corrigan on 7/10/10.
//  Copyright 2010 Roving Networks, Inc. All rights reserved.
//

#import "ManualVC.h"
#import "EAController.h"


@implementation ManualVC

@synthesize inputField = _inputField;


 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
	NSLog(@"ManualVC-initWithNibName:");
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]))
	{
        // Custom initialization
		UITabBarItem *tbItem = [self tabBarItem];
		[tbItem setTitle:@"Manual"];
		UIImage *tbImage = [UIImage imageNamed:@"writePost.png"];
		[tbItem setImage:tbImage];
    }
    return self;
}


/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];

	CGRect r = [[self view] frame];
	r.origin.y += 20;
	[[self view] setFrame:r];
}



// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
//    return (UIInterfaceOrientationPortrait == interfaceOrientation);
	return YES;
}


- (void)viewWillAppear:(BOOL)animated
{
	NSLog(@"ManualVC-viewWillAppear:");
    [super viewWillAppear:animated];
	[[EAController sharedController] openSession];
}



- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)dealloc
{
	[_inputField release];
	[_textView release];
	[_group1 release];
	[_group2 release];
	[_statusGroup release];
	[_protocolLabel release];
	[_statusLabel release];
    [super dealloc];
}


- (IBAction)turnOnLED:(id)sender
{
    const uint8_t buf[2] = {0x98, 0x01};
    [[EAController sharedController] writeData:[NSData dataWithBytes:buf length:2]];
	
}


- (IBAction)turnOffLED:(id)sender
{
    const uint8_t buf[2] = {0x98, 0x00};
    [[EAController sharedController] writeData:[NSData dataWithBytes:buf length:2]];
}


- (IBAction)doSend:(id)sender
{
	NSMutableString *s = [[NSMutableString alloc] initWithString:[_inputField text]];
	[s appendFormat:@"\r\n"];
	const char *cStr = [s UTF8String];
	int len = strlen(cStr);
#if 0
	NSRange r = NSMakeRange(0, [s length]);
	[s getCharacters:(unichar *)buf range:r];
	[[EAController sharedController] writeData:[NSData dataWithBytes:buf length:[s length]]];
#endif
	[[EAController sharedController] writeData:[NSData dataWithBytes:cStr length:len]];
	[_inputField setText:@""];
	[s release];
}


- (void)showAccessoryInfo:(id)sender
{
	EAAccessory *accessory = [[EAController sharedController] selectedAccessory];
    UIAlertView *accessoryInfo = [[UIAlertView alloc] initWithTitle:[accessory name] message:[accessory description] delegate:nil cancelButtonTitle:@"Dismiss" otherButtonTitles:nil];
    [accessoryInfo show];
    [accessoryInfo release];
}


-(void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
	NSLog(@"touchesEnded:");
	[_inputField resignFirstResponder];
}


@end
