    //
//  MoreVC.m
//  RN-iAP
//
//  Created by Phillip Corrigan on 7/17/10.
//  Copyright 2010 Roving Networks, Inc. All rights reserved.
//

#import "MoreVC.h"
#import "EAController.h"


@implementation MoreVC


 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
	NSLog(@"MoreVC-initWithNibName:");
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]))
	{
        // Custom initialization
		UITabBarItem *tbItem = [self tabBarItem];
		[tbItem setTitle:@"More"];
		UIImage *tbImage = [UIImage imageNamed:@"more.png"];
		[tbItem setImage:tbImage];
    }
    return self;
}


/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
//    return (interfaceOrientation == UIInterfaceOrientationPortrait);
	return YES;
}


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


- (IBAction)turnOnLED:(id)sender
{
    const uint8_t buf[2] = {0x98, 0x01};
    [[EAController sharedController] writeData:[NSData dataWithBytes:buf length:2]];
	[self appendData:@"Sent {0x98, 0x01}\n"];
}


- (IBAction)turnOffLED:(id)sender
{
    const uint8_t buf[2] = {0x98, 0x00};
    [[EAController sharedController] writeData:[NSData dataWithBytes:buf length:2]];
	[self appendData:@"Sent {0x98, 0x00}\n"];
}


- (IBAction)send10bytes:(id)sender
{
	
	uint8_t buf[12];
    for(int i = 0; i < 10; i++)
	{
        buf[i] = (0x30 + i);  // fill buf with incrementing bytes;
    }
    buf[10] = '\r';
    buf[11] = '\n';
    [[EAController sharedController] writeData:[NSData dataWithBytes:buf length:12]];
    buf[10] = '\0';
	NSString *d = [[[NSString alloc] initWithUTF8String:(const char *)buf] autorelease];
	NSString *s = [NSString stringWithFormat:@"%@ %@%@", @"Sent 10 bytes: ", d, @"\n"];
	[self appendData:s];
}


- (IBAction)send100bytes:(id)sender
{
	
	uint8_t buf[102];
    for(int i = 0; i < 100; i++)
	{
        buf[i] = (arc4random() % 93) + 0x21;
    }
    buf[100] = '\r';
    buf[101] = '\n';
    [[EAController sharedController] writeData:[NSData dataWithBytes:buf length:102]];
    buf[100] = '\0';
	NSString *d = [[[NSString alloc] initWithUTF8String:(const char *)buf] autorelease];
	NSString *s = [NSString stringWithFormat:@"%@ %@%@", @"Sent 100 bytes: ", d, @"\n"];
	[self appendData:s];
}


- (IBAction)send10K:(id)sender
{
    uint8_t buf[10002];
    for(int i = 0; i < 10000; i++)
	{
        buf[i] = (arc4random() % 93) + 0x21;
//        buf[i] = (i & 0xFF);  // fill buf with incrementing bytes;
    }
    buf[10000] = '\r';
    buf[10001] = '\n';
    [[EAController sharedController] writeData:[NSData dataWithBytes:buf length:10002]];
    buf[10000] = '\0';
	NSString *d = [[[NSString alloc] initWithUTF8String:(const char *)buf] autorelease];
	NSString *s = [NSString stringWithFormat:@"%@ %@%@", @"Sent 10k bytes:\n", d, @"\n"];
	[self appendData:s];
}


@end
