//
//  AppDelegate_iPad.m
//  RN-iAP
//
//  Created by Phillip Corrigan on 7/10/10.
//  Copyright Roving Networks, Inc 2010. All rights reserved.
//

#import "AppDelegate_iPad.h"
#import "EAController.h"
#import "ManualVC.h"
#import "LoopbackVC.h"
#import "MoreVC.h"


@implementation AppDelegate_iPad

@synthesize window = _window;
@synthesize tabBarController = _tabBarController;


#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
	
    // Override point for customization after application launch.
	ManualVC *manualVC = [[[ManualVC alloc] initWithNibName:@"ManualVC_iPad" bundle:nil] autorelease];
	LoopbackVC *loobackVC = [[[LoopbackVC alloc] initWithNibName:@"LoopbackVC_iPad" bundle:nil] autorelease];
	MoreVC *moreVC = [[[MoreVC alloc] initWithNibName:@"MoreVC_iPad" bundle:nil] autorelease];
	_tabBarController = [[UITabBarController alloc] initWithNibName:nil bundle:nil];
	[_tabBarController setViewControllers:[NSArray arrayWithObjects:manualVC, loobackVC, moreVC, nil]];
	[_window addSubview:[_tabBarController view]];
    [_window makeKeyAndVisible];
	
	return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive.
     */
}


- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     */
	[[EAController sharedController] closeSession];
}


#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application
{
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}


- (void)dealloc
{
    [_tabBarController release];
    [_window release];
    [super dealloc];
}


@end
